<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Opcodes and Formats</TITLE>
<link href="suif1_25.html" rel=Next>
<link href="suif1_23.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_23.html">previous</A>, <A HREF="suif1_25.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC24" HREF="suif1_toc.html#TOC24">Opcodes and Formats</A></H3>
<P>
<A NAME="IDX135"></A>
<A NAME="IDX136"></A>

</P>
<P>
<A NAME="IDX137"></A>
<A NAME="IDX138"></A>
<A NAME="IDX139"></A>
<A NAME="IDX140"></A>
The <CODE>opcode</CODE> and <CODE>set_opcode</CODE> methods may be used to access
the opcode field in an instruction.  These opcodes are members of the
<CODE>if_ops</CODE> enumerated type.  The internal names for the opcodes all
begin with <CODE>io_</CODE>, but that prefix is omitted in this documentation.
The <CODE>if_ops_name</CODE> function takes an opcode and returns a character
string holding the opcode name (without the <CODE>io_</CODE> prefix).  This is
used by the library when it prints out instructions, but you may also
call it directly.

</P>
<P>
<A NAME="IDX141"></A>
<A NAME="IDX142"></A>
<A NAME="IDX143"></A>
Each opcode is associated with a particular instruction format.  The
formats are specified by members of the <CODE>inst_format</CODE> enumeration.
The <CODE>format</CODE> method may be used to retrieve the format for a
particular instruction.  Alternatively, the <CODE>which_format</CODE> function
takes an opcode and returns its format without reference to any
particular instruction.  Each format corresponds to a particular derived
instruction class:

</P>
<DL COMPACT>

<DT><CODE>inf_rrr</CODE>
<DD>
Three operand instructions use the <CODE>in_rrr</CODE> class.

<DT><CODE>inf_bj</CODE>
<DD>
Branch and jump instructions use the <CODE>in_bj</CODE> class.

<DT><CODE>inf_ldc</CODE>
<DD>
The load constant instruction uses the <CODE>in_ldc</CODE> class.

<DT><CODE>inf_cal</CODE>
<DD>
The call instruction uses the <CODE>in_cal</CODE> class.

<DT><CODE>inf_array</CODE>
<DD>
The array instruction uses the <CODE>in_array</CODE> class.

<DT><CODE>inf_mbr</CODE>
<DD>
The multi-way branch instruction uses the <CODE>in_mbr</CODE> class.

<DT><CODE>inf_lab</CODE>
<DD>
The label instruction uses the <CODE>in_lab</CODE> class.

<DT><CODE>inf_gen</CODE>
<DD>
Generic instructions use the <CODE>in_gen</CODE> class.
</DL>

<P>
The <CODE>format</CODE> method is often used in <CODE>switch</CODE> statements for
dealing with different kinds of instructions.  For example, the
following code computes the number of source operands in an instruction
(instead of using the <CODE>num_srcs</CODE> method):

</P>

<PRE>
instruction *i;
switch (i-&#62;format()) {
    case inf_rrr: {
        n += 2;
        break;
    }
    case inf_bj: {
        n += 1;
        break;
    }
    case inf_cal: {
        in_cal *cali = (in_cal *)i;
        n += 1 + cali-&#62;num_args();
        break;
    }
    case inf_array: {
        in_array *arri = (in_array *)i;
        n += 2 + 2 * arri-&#62;dims();
        break;
    }
    case inf_mbr: {
        n += 1;
        break;
    }
    case inf_gen: {
        in_gen *geni = (in_gen *)i;
        n += geni-&#62;num_srcs();
        break;
    }
    default: {
        /* other formats (inf_ldc and inf_lab) have no source operands */
        break;
    }
}
</PRE>

<P>
The opcodes and instruction formats are defined in the <TT>`opcodes.h'</TT>
and <TT>`opcodes.cc'</TT> files.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_23.html">previous</A>, <A HREF="suif1_25.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
